#pragma once

#include <limits.h>
#include "LongPointLib.h"
#include "LongRectangleLib.h"
#include "TE32K.h"

#define TE32K_MAX_LENGTH	(LONG_MAX)	/* maximum number of characters */
#define TE32K_MAX_LINES		(LONG_MAX)	/* maximum number of lines */

#define TE32KSelStart(te)				((**(te)).selStart)
#define TE32KSelStartSet(start, te) ((void) ((**(te)).selStart = (start)))
#define TE32KSelEnd(te)					((**(te)).selEnd)
#define TE32KSelEndSet(end, te) 		((void) ((**(te)).selEnd = (end)))
#define TE32KLength(te)					((**(te)).teLength)
#define TE32KLines(te)					((**(te)).nLines)
#define TE32KLineStart(line, te)		((**(te)).lineStarts[(line)])
#define TE32KLineEnd(line, te)		((**(te)).nLines == 0 ? 0 : (**(te)).lineStarts[(line) + 1])
#define TE32KText(te)					((**(te)).hText)
#define TE32KPort(te)					((**(te)).inPort)
#define TE32KPortSet(port, te)		((void) ((**(te)).inPort = (port)))
#define TE32KActive(te)					((**(te)).active != 0)
#define TE32KWrap(te)					((**(te)).crOnly == 0)
#define TE32KWrapSet(wrap, te)		((void) ((**(te)).crOnly = ! (wrap)))
#define TE32KClickLoopSet(loop, te)	((void) ((**(te)).clikLoop = (loop)))

/* point and offset */
void TE32KDoGetPoint(long offset, LPointType *lpt, TE32KHandle te);
long TE32KDoGetOffset(const LPointType *lpt, TE32KHandle te);

/* rectangles */
void TE32KView(Rect *view, TE32KHandle te);
void TE32KViewSet(const Rect *view, TE32KHandle te);
void TE32KDest(LRectType *dest, TE32KHandle te);
void TE32KDestSet(const LRectType *dest, TE32KHandle te);

/* style */
void TE32KStyleContinuous(short *modes, TextStyle *style, TE32KHandle te);
void TE32KStyle(TextStyle *style, short *height, short *ascent, TE32KHandle te);
void TE32KStyleSet(short mode, const TextStyle *style, Boolean redraw,
	TE32KHandle te);
StScrpHandle TE32KStyleScrap(TE32KHandle te);
void TE32KStyleScrapSet(StScrpHandle scrp, Boolean redraw, TE32KHandle te);

/* edit */
void TE32KDoCut(TE32KHandle te);
void TE32KDoCopy(TE32KHandle te);
void TE32KDoPaste(TE32KHandle te);

/* miscelaneous */
void TE32KReplaceText(Handle text, TE32KHandle te);
void TE32KDoActivate(Boolean active, TE32KHandle te);
void TE32KDoUpdate(const Rect *view, TE32KHandle te);
long TE32KGetHeight(long start, long end, TE32KHandle te);
